      PROGRAM POLTIDM
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C                                                                      !
C     Program POLTIDM, version 1997.08.21 Fortran 90.                  !
C                                                                      !
C     Computes the difference between poltide computed from old IERS   !
C     and new IERS EOP97 polar motion.                                 !
C                                                                      !
C     Used routines:                                                   !
C     --------------                                                   !
C     ETJULN: computes Julian date.                                    !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IMPLICIT DOUBLE PRECISION (D)
      CHARACTER CTEXT(8)*10,CENDT*10
      DATA IUN11/11/,IUN12/12/,IUN13/13/,IUN16/16/
      DATA CENDT/'C*********'/
      OPEN(UNIT=IUN11,FILE='bfhw9501.dat',FORM='FORMATTED') 
      OPEN(UNIT=IUN12,FILE='bfhw9502.dat',FORM='FORMATTED') 
      OPEN(UNIT=IUN16,FILE='poltidm.prn',FORM='FORMATTED')
  100 READ(IUN11,17001) (CTEXT(I),I=1,8)
      WRITE(*,17001)    (CTEXT(I),I=1,8)
      IF(CTEXT(1).NE.CENDT) GOTO 100
      READ(IUN11,17001) (CTEXT(I),I=1,8)
      READ(IUN11,17001) (CTEXT(I),I=1,8)
  110 READ(IUN12,17001) (CTEXT(I),I=1,8)
      WRITE(*,17001)    (CTEXT(I),I=1,8)
      IF(CTEXT(1).NE.CENDT) GOTO 110
      READ(IUN12,17001) (CTEXT(I),I=1,8)
      READ(IUN12,17001) (CTEXT(I),I=1,8)
  200 READ(IUN11,17002) IDAT1,ITIM1,DGTOT1,DGTID1,DGPOL1
      IF(IDAT1.EQ.99999999) GOTO 1000    
      READ(IUN12,17002) IDAT2,ITIM2,DGTOT2,DGTID2,DGPOL2
      IF(ITIM1.GT.0) GOTO 200 
      DIFF=DGPOL2-DGPOL1
      ITY=IDAT1/10000
      IDUM=IDAT1-10000*ITY
      ITM=IDUM/100
      ITD=IDUM-100*ITM
      ITH=ITIM1/10000
      DTH=DBLE(ITH)
      CALL ETJULN(IUN16,ITY,ITM,ITD,DTH,DJULD)
      DMODJUL=DJULD- 2400000.5D0
      WRITE(*,17003)     IDAT1,ITIM1,DMODJUL,DGPOL1,DGPOL2,DIFF
      WRITE(IUN16,17003) IDAT1,ITIM1,DMODJUL,DGPOL1,DGPOL2,DIFF
      GOTO 200
 1000 CONTINUE
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Format statements:                                               !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
17001 FORMAT(8A10)
17002 FORMAT(I8,1X,I6,5F10.3)
17003 FORMAT(1X,I8,1X,I6,5F10.3)
      END
C
      SUBROUTINE ETJULN(IUN16,ITY,ITM,ITD,DTH,DJULD)
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C                                                                      !
C     Routine ETJULN, version 1996.05.25 Fortran 90.                   !
C                                                                      !
C     The routine ETJULN computes the Julian date and the modified     !
C     Julian date. ETJULN is a modified version of routine MJD given   !
C     in PASCAL by Montenbruck and Pfleger (see below).                !
C                                                                      !
C     The routine is valid for every date since year -4713.            !
C     Comparison with reference values between years -1410 and +3200   !
C     from JPL was successfully.                                       ! 
C                                                                      !
C     Reference: Montenbruck, O. and T. Pfleger (1989): Astronomie mit !
C                dem Personal Computer. Springer Verlag, Berlin 1989.  !
C                                                                      !
C     Input parameter description:                                     !
C     ----------------------------                                     !
C                                                                      !
C     ITY:         Year   (INTEGER).                                   !
C     ITM:         Month  (INTEGER).                                   !
C     ITD:         Day    (INTEGER).                                   !
C     DTH:         Hour   (DOUBLE PRECISION).                          !
C                                                                      !
C     Output parameter description:                                    !
C     -----------------------------                                    !
C                                                                      !
C     DJULD:       Julian date (DOUBLE PRECISION).                     !
C                  16. April   -1410, 0.00 H is DJULD = 1206160.5D0    !
C                  31. January -1100, 0.00 H is DJULD = 1319312.5D0    !
C                  24. January -0800, 0.00 H is DJULD = 1428880.5D0    !
C                  17. January -0500, 0.00 H is DJULD = 1538448.5D0    !
C                  10. January -0200, 0.00 H is DJULD = 1648016.5D0    !
C                  03. January   100, 0.00 H is DJULD = 1757584.5D0    !
C                  29. February  400, 0.00 H is DJULD = 1867216.5D0    !
C                  20. December  699, 0.00 H is DJULD = 1976720.5D0    !
C                  15. February 1000, 0.00 H is DJULD = 2086352.5D0    !
C                  08. February 1300, 0.00 H is DJULD = 2195920.5D0    !
C                  11. February 1600, 0.00 H is DJULD = 2305488.5D0    !
C                  06. February 1900, 0.00 H is DJULD = 2415056.5D0    ! 
C                  01. January  1988, 0.00 H is DJULD = 2447161.5D0    !
C                  01. February 1988, 0.00 H is DJULD = 2447192.5D0    !
C                  29. February 1988, 0.00 H is DJULD = 2447220.5D0    !
C                  01. March    1988, 0.00 H is DJULD = 2447221.5D0    !
C                  01. February 2200, 0.00 H is DJULD = 2524624.5D0    !
C                  27. January  2500, 0.00 H is DJULD = 2634192.5D0    !
C                  23. January  2800, 0.00 H is DJULD = 2743760.5D0    !
C                  22. December 3002, 0.00 H is DJULD = 2817872.5D0    ! 
C                                                                      !
C     To obtain the modified Julian date, subtract 2400000.5 from      !
C     DJULD.                                                           !
C                                                                      !
C     Execution time:                                                  !
C     ---------------                                                  !
C                                                                      !
C     2.42 microsec per call on a Pentium 100 MHz using Lahex LF90     !
C     compiler.                                                        !
C                                                                      !
C     Routine creation:  1992.09.19 by Hans-Georg Wenzel,              !
C                        Black Forest Observatory,                     !
C                        Universitaet Karlsruhe,                       !
C                        Englerstr. 7,                                 !
C                        D-76128 KARLSRUHE,                            !
C                        Germany.                                      !
C                        Tel.: 0721-6082301.                           !
C                        FAX:  0721-694552.                            !
C                        e-mail: wenzel@gik.bau-verm.uni-karlsruhe.de  !
C     Last modification: 1996.05.25 by Hans-Georg Wenzel.              !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IMPLICIT DOUBLE PRECISION (D)
      SAVE
      ITYY=ITY
      IF(ITM.LT.1) GOTO 5000
      IF(ITM.GT.12) GOTO 5010
      ITMM=ITM
      DA=10000.0D0*ITYY+100.0D0*ITMM+ITD
      IF(ITMM.LE.2) THEN
         ITMM=ITMM+12
         ITYY=ITYY-1
      ENDIF
      IF(DA.LE.15821004.1D0) THEN
         DB=-2+(ITYY+4716)/4-1179
      ELSE
         DB=ITYY/400-ITYY/100+ITYY/4
      ENDIF
      DA=365.0D0*DBLE(ITYY)-679004.0D0
      DJULD=DA+DB+INT(30.6001D0*(ITMM+1))+DBLE(ITD)+DTH/24.D0
     1 +2400000.5D0
      RETURN
 5000 WRITE(IUN16,17050) ITY,ITM,ITD,DTH
      STOP
 5010 WRITE(IUN16,17051) ITY,ITM,ITD,DTH
      STOP
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Format statements:                                               !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
17050 FORMAT(/' *****Error in routine ETJULN, version 1996.05.25.'/
     1' *****Month is less 1:',2X,3I4,F12.3/
     2' *****Routine ETJULN stops the execution.'/)
17051 FORMAT(/' *****Error in routine ETJULN, version 1996.05.25.'/
     1' *****Month is greater 12:',2X,3I4,F12.3/
     2' *****Routine ETJULN stops the execution.'/)
      END
